function Msg(value)

    reaper.ShowConsoleMsg(tostring(value) .. "\n")

end


--retval, measures, cml, fullbeats, cdenom = reaper.TimeMap2_timeToBeats(0, cur_pos)
--current_measure = reaper.TimeMap2_beatsToTime(0, fullbeats +1)


function barbeatcursor(proj, barpos, beatpos) -- TimeMap2_beatsToTime() straight or swing grid
  
  set_cur = reaper.TimeMap2_beatsToTime( 0, 0, barpos )
  reaper.SetEditCurPos2( 0, set_cur, 0, 0 )
  local cur_pos = reaper.GetCursorPosition()
  local timesig_num, timesig_denom, tempo = reaper.TimeMap_GetTimeSigAtTime( proj, cur_pos )
  if beatpos +1  > timesig_num then beatpos = timesig_num -1  
  else beatpos = beatpos end
  local retval, division, swing, swingamt = reaper.GetSetProjectGrid(proj,false)
   if swing and swingamt ~= 0 and division > 0 then
     beatpos = beatpos / (division*4)
     local fullb = math.floor(beatpos/2)*2
     beatpos = beatpos - fullb
     -- beatpos is [0..2), swingamt is -1..1, map 1 to 1+swingamt*.5
     beatpos = beatpos + (swingamt*.5)*(1-math.abs(beatpos-1))
     beatpos = (fullb + beatpos) * division * 2
     beatpos = set_cur + beatpos
     reaper.SetEditCurPos2( proj, beatpos, 0, 0 )
   else
    set_cur = reaper.TimeMap2_beatsToTime( 0, beatpos, barpos )
    reaper.SetEditCurPos2( proj, set_cur, 0, 0 )
   end 
  return beatpos
end

setbar = 3
setbeat = 4

barbeatcursor(0, setbar -1, setbeat -1) -- (proj, bar -1, beat -1)









function unswingbeats(proj, beatpos) -- TimeMap2_timetoBeats()
  local retval, division, swing, swingamt = reaper.GetSetProjectGrid(proj,false)
  if swing and swingamt ~= 0 and division > 0 then
    beatpos = beatpos / (division*4)
    Msg("swing ".. swing)
    Msg("swingamt ".. swingamt)
    Msg("division ".. division)
    swingamt = swingamt*.5
    local fullb = math.floor(beatpos/2)*2
    Msg("fullb ".. fullb)
    beatpos = beatpos - fullb
    --beatpos = beatpos +1
    
    -- beatpos is [0..2), map 1+swingamt to 1
    local div = 1+swingamt
    if beatpos <= div then
      beatpos = beatpos / div
    else
      beatpos = 1.0 + (beatpos - div) / (2 - div)
    end
    beatpos = (fullb + beatpos) * division * 4
  end
  Msg("beatpos ".. beatpos)
  return beatpos
end
--NOT WORKING
--cur_pos2 = swingbeats(0, 3 -1)
--cur_pos2 = unswingbeats(0, cur_pos)
--Msg("cur_pos ".. cur_pos)
--_Msg("cur_pos2 ".. cur_pos2 )

--reaper.SetEditCurPos2( 0, cur_pos2, 0, 0 )
--retval, measures, cml, fullbeats, cdenom = reaper.TimeMap2_timeToBeats( 0, cur_pos )
 
--Msg("measures ".. measures .." cml ".. fullbeats .." cdenom ".. cdenom)
